package com.dzeio.openhealth.data.water

import javax.inject.Inject
import javax.inject.Singleton
import kotlinx.coroutines.flow.filter

@Singleton
class WaterRepository @Inject constructor(
    private val waterDao: WaterDao
) {
    fun getWaters() = waterDao.getAll()

    fun lastWater() = waterDao.last()

    fun getWater(id: Long) = waterDao.getOne(id)

    suspend fun addWater(value: Water) = waterDao.insert(value)
    suspend fun deleteWater(value: Water) = waterDao.delete(value)
    suspend fun deleteFromSource(value: String) = waterDao.deleteFromSource(value)

    fun todayWater() = lastWater().filter {
        return@filter it != null && it.isToday()
    }
}
