package com.dzeio.openhealth.data.weight

import androidx.room.Dao
import androidx.room.Query
import com.dzeio.openhealth.core.BaseDao
import kotlinx.coroutines.flow.Flow

@Dao
interface WeightDao : BaseDao<Weight> {

    @Query("SELECT * FROM Weight ORDER BY timestamp")
    fun getAll(): Flow<List<Weight>>

    @Query("SELECT * FROM Weight WHERE id = :weightId")
    fun getOne(weightId: Long): Flow<Weight?>

    @Query("Select count(*) from Weight")
    fun getCount(): Flow<Int>

    @Query("Select * FROM Weight WHERE id=(SELECT max(id) FROM Weight)")
    fun last(): Flow<Weight?>

    @Query("DELETE FROM Weight where source = :source")
    suspend fun deleteFromSource(source: String)
}
