package com.dzeio.openhealth.devices

import com.dzeio.openhealth.core.Observable
import com.dzeio.openhealth.data.weight.Weight
import com.dzeio.openhealth.utils.Configuration

abstract class Device<T>(
    val config: Configuration
) {

    abstract val name: String
    var item: T? = null

    enum class ConnectionStatus {
        DISCONNECTED,
        CONNECTING,
        CONNECTED,
        ERROR
    }

    data class FetchStatus(
        var progress: Int,
        var progressMax: Int,
        val data: ArrayList<Weight> = arrayListOf()
    )

//    enum class ActionStatus {}

    abstract fun isOfType(item: T): Boolean

    abstract fun search(): Observable<T?>

    abstract fun connect(): Observable<ConnectionStatus>

    abstract fun fetchWeights(): Observable<FetchStatus>

    abstract fun reset()
}
