package com.dzeio.openhealth.utils.polyfills

import android.bluetooth.BluetoothGatt
import android.bluetooth.BluetoothGattCharacteristic
import android.bluetooth.BluetoothGattDescriptor
import android.os.Build
import androidx.annotation.RequiresPermission

@RequiresPermission(value = "android.permission.BLUETOOTH_CONNECT")
fun BluetoothGatt.writeCharacteristicPoly(
    characteristic: BluetoothGattCharacteristic,
    value: ByteArray,
    writeType: Int
) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
        this.writeCharacteristic(
            characteristic,
            value,
            writeType
        )
    } else {
        @Suppress("DEPRECATION")
        characteristic.value = value
        @Suppress("DEPRECATION")
        this.writeCharacteristic(characteristic)
    }
}

@RequiresPermission(value = "android.permission.BLUETOOTH_CONNECT")
fun BluetoothGatt.writeDescriptorPoly(
    descriptor: BluetoothGattDescriptor,
    value: ByteArray
) {
    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
        this.writeDescriptor(
            descriptor,
            value
        )
    } else {
        @Suppress("DEPRECATION")
        descriptor.value = value
        @Suppress("DEPRECATION")
        this.writeDescriptor(descriptor)
    }
}
